package modulesAndPopups.modules.windows.views.mediators
{
	import flash.events.Event;

	import modulesAndPopups.modules.windows.controllers.events.SparkWindowEvent;

	import robotlegs.bender.bundles.mvcs.Mediator;
	import robotlegs.bender.extensions.viewManager.api.IViewManager;
	import modulesAndPopups.modules.windows.views.components.SomeWindow;

	public class SomeWindowMediator extends Mediator
	{
		[Inject]
		public var view:SomeWindow;

		[Inject]
		public var viewManager:IViewManager;

		override public function initialize():void
		{
			//listener for Spark Window's CLOSING event
			addViewListener(Event.CLOSING, onWindowClosing, Event);

			//listener for the event dispatched by SomeWindow after clicking a custom close Button
			addViewListener(SparkWindowEvent.CLOSE_SPARK_WINDOW, onCloseSparkWindow, SparkWindowEvent);

			//listener for the event dispatched by WindowOpenerMediator
			addContextListener(SparkWindowEvent.CLOSE_SPARK_WINDOW, onCloseSparkWindow, SparkWindowEvent);
		}

		private function onWindowClosing(event:Event):void
		{
			event.preventDefault();
			event.currentTarget.removeEventListener(Event.CLOSING, onWindowClosing);

			destroyView();
		}

		private function onCloseSparkWindow(event:SparkWindowEvent):void
		{
			destroyView();
		}

		private function destroyView():void
		{
			// remove any reference that could keep the view alive
			view.cleanUp();

			//close the window
			view.close();

			//remove it from the viewManager
			viewManager.removeContainer(view);

			//view = null;
		}
	}
}
