package modulesAndPopups.shell.views.mediators
{
	import modulesAndPopups.modules.windows.controllers.events.SparkWindowEvent;
	import modulesAndPopups.modules.windows.views.components.SomeSimpleView;
	import modulesAndPopups.modules.windows.views.components.SomeWindow;
	import modulesAndPopups.shell.views.components.WindowOpenerView;

	import robotlegs.bender.bundles.mvcs.Mediator;
	import robotlegs.bender.extensions.viewManager.api.IViewManager;

	public class WindowOpenerMediator extends Mediator
	{
		[Inject]
		public var view:WindowOpenerView;

		[Inject]
		public var viewManager:IViewManager;

		override public function initialize():void
		{
			addViewListener(SparkWindowEvent.OPEN_SPARK_WINDOW, onOpenSparkWindow, SparkWindowEvent);

			//redisptaching view's event; SomeWindowMediator will react to it:
			addViewListener(SparkWindowEvent.CLOSE_SPARK_WINDOW, dispatch, SparkWindowEvent);
		}

		private function onOpenSparkWindow(event:SparkWindowEvent):void
		{

			var someWindow:SomeWindow;
			someWindow = new SomeWindow();

			viewManager.addContainer(someWindow);

			var someSimpleView:SomeSimpleView = new SomeSimpleView();
			someSimpleView.y = 50;
			someWindow.addElement(someSimpleView);

			someWindow.open();
		}
	}
}
